//Source file: APIUnavailReason.java
//Date: June 2004
//Framework Data Types for 3GPP TS 29.198-03 V5.7.0

package org.csapi.jr.se.fw;

/**
 * The reason why the API is unavailable.
			Undefined.
			The local API software or hardware has failed.
			The gateway API software or
			hardware has failed.
			The framework is fully overloaded.
			The framework has closed itself.
			The protocol used on the client - gateway link has failed.
 *
 */
public final class APIUnavailReason implements java.io.Serializable {

    private int _value;
    private static int _size = 6;
    private static APIUnavailReason[] _array = new APIUnavailReason[_size];

    /**
     * Private constructor used internally to construct static objects 
     */
    private APIUnavailReason(int value) {
        _value = value;
        _array[_value] = this;
    }

    /**
     * 
     */
    public static final int _API_UNAVAILABLE_UNDEFINED =  0;

    /**
     * 
     */
    public static final APIUnavailReason API_UNAVAILABLE_UNDEFINED = new APIUnavailReason(_API_UNAVAILABLE_UNDEFINED);

    /**
     * 
     */
    public static final int _API_UNAVAILABLE_LOCAL_FAILURE =  1;

    /**
     * 
     */
    public static final APIUnavailReason API_UNAVAILABLE_LOCAL_FAILURE = new APIUnavailReason(_API_UNAVAILABLE_LOCAL_FAILURE);

    /**
     * 
     */
    public static final int _API_UNAVAILABLE_GATEWAY_FAILURE =  2;

    /**
     * 
     */
    public static final APIUnavailReason API_UNAVAILABLE_GATEWAY_FAILURE = new APIUnavailReason(_API_UNAVAILABLE_GATEWAY_FAILURE);

    /**
     * 
     */
    public static final int _API_UNAVAILABLE_OVERLOADED =  3;

    /**
     * 
     */
    public static final APIUnavailReason API_UNAVAILABLE_OVERLOADED = new APIUnavailReason(_API_UNAVAILABLE_OVERLOADED);

    /**
     * 
     */
    public static final int _API_UNAVAILABLE_CLOSED =  4;

    /**
     * 
     */
    public static final APIUnavailReason API_UNAVAILABLE_CLOSED = new APIUnavailReason(_API_UNAVAILABLE_CLOSED);

    /**
     * 
     */
    public static final int _API_UNAVAILABLE_PROTOCOL_FAILURE =  5;

    /**
     * 
     */
    public static final APIUnavailReason API_UNAVAILABLE_PROTOCOL_FAILURE = new APIUnavailReason(_API_UNAVAILABLE_PROTOCOL_FAILURE);


    /**
     * Method allows class to replace/resolve the object read from the stream before it 
     * is returned to the caller. By implementing this method, a class can directly control
     * the types and instances of its own instances being deserialized.
     *
     * @return the resolved APIUnavailReason object 
     */
    private Object readResolve() throws java.io.ObjectStreamException {
        return _array[_value];
    }

    /**
     * Number representing enum type
     *
     * @return int number representing type of object, this is defined within the class
     */
    public int getValue() {
        return _value;
    }

    /**
     * getValueText method, overrides the getValueText() method in class java.lang.Object
     *
     * @return String  The stringified version of the APIUnavailReason object
     */
    public String getValueText() {
        switch (_value) {
            case _API_UNAVAILABLE_UNDEFINED:
                return "API_UNAVAILABLE_UNDEFINED";
            case _API_UNAVAILABLE_LOCAL_FAILURE:
                return "API_UNAVAILABLE_LOCAL_FAILURE";
            case _API_UNAVAILABLE_GATEWAY_FAILURE:
                return "API_UNAVAILABLE_GATEWAY_FAILURE";
            case _API_UNAVAILABLE_OVERLOADED:
                return "API_UNAVAILABLE_OVERLOADED";
            case _API_UNAVAILABLE_CLOSED:
                return "API_UNAVAILABLE_CLOSED";
            case _API_UNAVAILABLE_PROTOCOL_FAILURE:
                return "API_UNAVAILABLE_PROTOCOL_FAILURE";
            default:
                return "ERROR";
        }
    }

    /**
     * Accepts values in the range of 0 to 5
     *
     * @param value number representing type of object, this is defined within the class
     * @throws org.csapi.jr.se.InvalidEnumValueException thrown if invalid value is passed into method
     */
    public static APIUnavailReason getObject(int value) throws org.csapi.jr.se.InvalidEnumValueException {
        if(value >= 0 && value < _size) {
            return _array[value];
        } else {
            throw new org.csapi.jr.se.InvalidEnumValueException("value [" + value +" ] out of range");
        }
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof APIUnavailReason)) {
            return false;
        }
        APIUnavailReason aPIUnavailReason = (APIUnavailReason) o; 
        if(!(this.getValue() == aPIUnavailReason.getValue())) {
            return false;
        }
        if (this.hashCode() != aPIUnavailReason.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // APIUnavailReason

