//Source file: EntOp.java
//Date: June 2004
//Framework Data Types for 3GPP TS 29.198-03 V5.7.0

package org.csapi.jr.se.fw;

/**
 * This data type is a Sequence of Data Elements which describes an enterprise operator. It is a structured data type, consisting of a unique 'enterprise operator ID' and a list of 'enterprise operator properties'.
 * 
 */
public final class EntOp implements java.io.Serializable {

    private String entOpID;
    private org.csapi.jr.se.fw.Property[] entOpProperties;

    /**
     * Creates a new EntOp instance.
     */
    public EntOp () {}

    /**
     * Creates a new EntOp instance.
     * @param _entOpID   
     * @param _entOpProperties   
     */
    public EntOp (String _entOpID, org.csapi.jr.se.fw.Property[] _entOpProperties) {

        this.entOpID = _entOpID;
        this.entOpProperties = _entOpProperties;
    }

    /**
     * This method returns a entOpID.
     * 
     * @return a String value
     */
    public String getEntOpID() {
        return entOpID;
    }

    /**
     * This method returns a entOpProperties.
     * 
     * @return a org.csapi.jr.se.fw.Property[] value
     */
    public org.csapi.jr.se.fw.Property[] getEntOpProperties() {
        return entOpProperties;
    }


    /**
     * This method sets a entOpID.
     */ 
    public void setEntOpID(String entOpID) {
        this.entOpID = entOpID;
    }

    /**
     * This method sets a entOpProperties.
     */ 
    public void setEntOpProperties(org.csapi.jr.se.fw.Property[] entOpProperties) {
        this.entOpProperties = entOpProperties;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof EntOp)) {
            return false;
        } 
        EntOp entOp = (EntOp) o;
        if(!(this.entOpProperties == entOp.entOpProperties))  {
            return false;
        }
        if(!(this.entOpID == entOp.entOpID))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // EntOp

