//Source file: FwEventInfo.java
//Date: June 2004
//Framework Data Types for 3GPP TS 29.198-03 V5.7.0

package org.csapi.jr.se.fw;

/**
 * Defines the Tagged Choice of Data Elements that specify the information returned to the application in an event notification.
 *
 */
public final class FwEventInfo implements java.io.Serializable {

    private FwEventName _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new FwEventInfo.
     * Tagged choice of data elements always have empty constructors
     */ 
    public FwEventInfo() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a FwEventName value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public FwEventName getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a EventNameUndefined
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getEventNameUndefined() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_NAME_UNDEFINED) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a EventNameUndefined
     * 
     * @param value a java.lang.String value
     */
    public void setEventNameUndefined(java.lang.String value) {
        _discriminator = FwEventName.EVENT_FW_NAME_UNDEFINED;
        _object = value;
    }

    /**
     * This method returns a ServiceIDList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getServiceIDList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_SERVICE_AVAILABLE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a ServiceIDList
     * 
     * @param value a String[] value
     */
    public void setServiceIDList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_SERVICE_AVAILABLE;
        _object = value;
    }

    /**
     * This method returns a UnavailableServiceIDList
     * 
     * @return  a String[] value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public String[] getUnavailableServiceIDList() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != FwEventName.EVENT_FW_SERVICE_UNAVAILABLE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return ((String[]) _object);
    }

    /**
     * This method sets a UnavailableServiceIDList
     * 
     * @param value a String[] value
     */
    public void setUnavailableServiceIDList(String[] value) {
        _discriminator = FwEventName.EVENT_FW_SERVICE_UNAVAILABLE;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a FwEventName value 
     */ 
    public void setUndefined(FwEventName discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof FwEventInfo)) {
            return false;
        } else {
            FwEventInfo fwEventInfo= (FwEventInfo)o;
            if(!(this._object.equals(fwEventInfo._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(fwEventInfo._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // FwEventInfo

