//Source file: LoadStatisticData.java
//Date: June 2004
//Framework Data Types for 3GPP TS 29.198-03 V5.7.0

package org.csapi.jr.se.fw;

/**
 * Defines the Sequence of Data Elements that represents load statistic information.
NOTE:	LoadValue is expressed as a percentage.
 * 
 */
public final class LoadStatisticData implements java.io.Serializable {

    private float loadValue;
    private org.csapi.jr.se.fw.LoadLevel loadLevel;

    /**
     * Creates a new LoadStatisticData instance.
     */
    public LoadStatisticData () {}

    /**
     * Creates a new LoadStatisticData instance.
     * @param _loadValue   
     * @param _loadLevel   
     */
    public LoadStatisticData (float _loadValue, org.csapi.jr.se.fw.LoadLevel _loadLevel) {

        this.loadValue = _loadValue;
        this.loadLevel = _loadLevel;
    }

    /**
     * This method returns a loadValue.
     * 
     * @return a float value
     */
    public float getLoadValue() {
        return loadValue;
    }

    /**
     * This method returns a loadLevel.
     * 
     * @return a org.csapi.jr.se.fw.LoadLevel value
     */
    public org.csapi.jr.se.fw.LoadLevel getLoadLevel() {
        return loadLevel;
    }


    /**
     * This method sets a loadValue.
     */ 
    public void setLoadValue(float loadValue) {
        this.loadValue = loadValue;
    }

    /**
     * This method sets a loadLevel.
     */ 
    public void setLoadLevel(org.csapi.jr.se.fw.LoadLevel loadLevel) {
        this.loadLevel = loadLevel;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof LoadStatisticData)) {
            return false;
        } 
        LoadStatisticData loadStatisticData = (LoadStatisticData) o;
        if ((this.loadLevel != null) && (loadStatisticData.loadLevel != null)) {
            if(!(this.loadLevel.equals(loadStatisticData.loadLevel))) {
                return false;
            }
        }
        if(!(this.loadValue == loadStatisticData.loadValue)) {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // LoadStatisticData

