//Source file: LoadStatisticEntityID.java
//Date: June 2004
//Framework Data Types for 3GPP TS 29.198-03 V5.7.0

package org.csapi.jr.se.fw;

/**
 * Defines the Tagged Choice of Data Elements that specify the type of entity (that is service, application or Framework) providing load statistics.
 *
 */
public final class LoadStatisticEntityID implements java.io.Serializable {

    private LoadStatisticEntityType _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new LoadStatisticEntityID.
     * Tagged choice of data elements always have empty constructors
     */ 
    public LoadStatisticEntityID() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a LoadStatisticEntityType value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public LoadStatisticEntityType getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a ClientAppID
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getClientAppID() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != LoadStatisticEntityType.LOAD_STATISTICS_APP_TYPE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a ClientAppID
     * 
     * @param value a java.lang.String value
     */
    public void setClientAppID(java.lang.String value) {
        _discriminator = LoadStatisticEntityType.LOAD_STATISTICS_APP_TYPE;
        _object = value;
    }

    /**
     * This method returns a FrameworkID
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getFrameworkID() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != LoadStatisticEntityType.LOAD_STATISTICS_FW_TYPE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a FrameworkID
     * 
     * @param value a java.lang.String value
     */
    public void setFrameworkID(java.lang.String value) {
        _discriminator = LoadStatisticEntityType.LOAD_STATISTICS_FW_TYPE;
        _object = value;
    }

    /**
     * This method returns a ServiceID
     * 
     * @return  a java.lang.String value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public java.lang.String getServiceID() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != LoadStatisticEntityType.LOAD_STATISTICS_SVC_TYPE) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.String) _object));
    }

    /**
     * This method sets a ServiceID
     * 
     * @param value a java.lang.String value
     */
    public void setServiceID(java.lang.String value) {
        _discriminator = LoadStatisticEntityType.LOAD_STATISTICS_SVC_TYPE;
        _object = value;
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a LoadStatisticEntityType value 
     */ 
    public void setUndefined(LoadStatisticEntityType discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof LoadStatisticEntityID)) {
            return false;
        } else {
            LoadStatisticEntityID loadStatisticEntityID= (LoadStatisticEntityID)o;
            if(!(this._object.equals(loadStatisticEntityID._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(loadStatisticEntityID._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // LoadStatisticEntityID

