//Source file: Service.java
//Date: June 2004
//Framework Data Types for 3GPP TS 29.198-03 V5.7.0

package org.csapi.jr.se.fw;

/**
 * This data type is a Sequence of Data Elements which describes a registered SCFs. It is a structured type which consists of ServiceID and ServiceDescription.
 * 
 */
public final class Service implements java.io.Serializable {

    private String serviceID;
    private org.csapi.jr.se.fw.ServiceDescription serviceDescription;

    /**
     * Creates a new Service instance.
     */
    public Service () {}

    /**
     * Creates a new Service instance.
     * @param _serviceID   
     * @param _serviceDescription   This field contains the description of the service
     */
    public Service (String _serviceID, org.csapi.jr.se.fw.ServiceDescription _serviceDescription) {

        this.serviceID = _serviceID;
        this.serviceDescription = _serviceDescription;
    }

    /**
     * This method returns a serviceID.
     * 
     * @return a String value
     */
    public String getServiceID() {
        return serviceID;
    }

    /**
     * This method returns a serviceDescription.
     * 
     * @return a org.csapi.jr.se.fw.ServiceDescription value
     */
    public org.csapi.jr.se.fw.ServiceDescription getServiceDescription() {
        return serviceDescription;
    }


    /**
     * This method sets a serviceID.
     */ 
    public void setServiceID(String serviceID) {
        this.serviceID = serviceID;
    }

    /**
     * This method sets a serviceDescription.
     */ 
    public void setServiceDescription(org.csapi.jr.se.fw.ServiceDescription serviceDescription) {
        this.serviceDescription = serviceDescription;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof Service)) {
            return false;
        } 
        Service service = (Service) o;
        if(!(this.serviceID == service.serviceID))  {
            return false;
        }
        if ((this.serviceDescription != null) && (service.serviceDescription != null)) {
            if(!(this.serviceDescription.equals(service.serviceDescription))) {
                return false;
            }
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // Service

