//Source file: ServiceDescription.java
//Date: June 2004
//Framework Data Types for 3GPP TS 29.198-03 V5.7.0

package org.csapi.jr.se.fw;

/**
 * This data type is a Sequence of Data Elements which describes a registered SCF. It is a structured data type which consists of ServiceTypeName and ServicePropertyList.
 * 
 */
public final class ServiceDescription implements java.io.Serializable {

    private String serviceTypeName;
    private org.csapi.jr.se.fw.ServiceProperty[] servicePropertyList;

    /**
     * Creates a new ServiceDescription instance.
     */
    public ServiceDescription () {}

    /**
     * Creates a new ServiceDescription instance.
     * @param _serviceTypeName   
     * @param _servicePropertyList   
     */
    public ServiceDescription (String _serviceTypeName, org.csapi.jr.se.fw.ServiceProperty[] _servicePropertyList) {

        this.serviceTypeName = _serviceTypeName;
        this.servicePropertyList = _servicePropertyList;
    }

    /**
     * This method returns a serviceTypeName.
     * 
     * @return a String value
     */
    public String getServiceTypeName() {
        return serviceTypeName;
    }

    /**
     * This method returns a servicePropertyList.
     * 
     * @return a org.csapi.jr.se.fw.ServiceProperty[] value
     */
    public org.csapi.jr.se.fw.ServiceProperty[] getServicePropertyList() {
        return servicePropertyList;
    }


    /**
     * This method sets a serviceTypeName.
     */ 
    public void setServiceTypeName(String serviceTypeName) {
        this.serviceTypeName = serviceTypeName;
    }

    /**
     * This method sets a servicePropertyList.
     */ 
    public void setServicePropertyList(org.csapi.jr.se.fw.ServiceProperty[] servicePropertyList) {
        this.servicePropertyList = servicePropertyList;
    }


    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) { 
            return false;
        }
        if(!(o instanceof ServiceDescription)) {
            return false;
        } 
        ServiceDescription serviceDescription = (ServiceDescription) o;
        if(!(this.serviceTypeName == serviceDescription.serviceTypeName))  {
            return false;
        }
        if(!(this.servicePropertyList == serviceDescription.servicePropertyList))  {
            return false;
        }
        if (this.hashCode() != o.hashCode()) {
            return false;
        }
        return true;
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // ServiceDescription

