//Source file: AppHeartBeatMgmt.java
//Date: June 2004
//Framework to Application Interfaces for 3GPP TS 29.198-03 V5.7.0

package org.csapi.jr.se.fw.fw_application.integrity;

/**
 * This interface allows the initialisation of a heartbeat supervision of the client application by the framework.  
 *
 */
public interface AppHeartBeatMgmt extends org.csapi.jr.se.CsapiInterface{

    /**
     * With this method, the framework instructs the client application to begin sending its heartbeat to the specified interface at the specified interval.
     * @param interval The time interval in milliseconds between the heartbeats.
     * @param CsapiInterface This parameter refers to the callback interface the heartbeat is calling.
     */
    void  enableAppHeartBeat(int interval, org.csapi.jr.se.fw.fw_application.integrity.HeartBeat CsapiInterface);

    /**
     * Instructs the client application to cease the sending of its heartbeat. 
     */
    void  disableAppHeartBeat();

    /**
     * Allows the administrative change of the heartbeat interval.
     * @param interval The time interval in milliseconds between the heartbeats.
     */
    void  changeInterval(int interval);


} // AppHeartBeatMgmt

