//Source file: FwOAM.java
//Date: June 2004
//Framework to Service Interfaces for 3GPP TS 29.198-03 V5.7.0

package org.csapi.jr.se.fw.fw_service.integrity;

/**
 * The OAM interface is used to query the system date and time. The service and the framework can synchronise the date and time to a certain extent.  Accurate time synchronisation is outside the scope of this API.  This interface and the systemDateTimeQuery() method are optional.
 *
 */
public interface FwOAM extends org.csapi.jr.se.CsapiInterface{

    /**
     * This method is used to query the system date and time. The client (service) passes in its own date and time to the framework. The framework responds with the system date and time.
     * @return systemDateAndTime    This is the system date and time of the framework.
     * @param clientDateAndTime This is the date and time of the client (service). The error code P_INVALID_DATE_TIME_FORMAT is returned if the format of the parameter is invalid.
     * @exception org.csapi.jr.se.CommonException     Defines the structure of the exception class which is applicable to all methods.
     * @exception org.csapi.jr.se.InvalidTimeAndDateFormatException     Invalid date and time format provided.
     * @exception org.csapi.jr.se.PlatformException     The implementation detected an internal (for example, communication) error
     */
    String  systemDateTimeQuery(String clientDateAndTime) throws org.csapi.jr.se.CommonException, org.csapi.jr.se.InvalidTimeAndDateFormatException, org.csapi.jr.se.PlatformException;


} // FwOAM

